; Paradox main

	DEVICE ZXSPECTRUM128

	MACRO DBW bt,wr
	 db bt
	 dw wr
	ENDM

	MACRO GETROW a1,a2
adru=a1
adrd=a2
	 DUP 10
	  DW adrd,adru
adrd=adrd+2
adru=adru+2
	 EDUP
	ENDM

	ORG 0xEA00

InHand	DS 22
XSIZE	DB 0		       ; field size
YSIZE	DB 0
FIELD	DS 0x200
Script	DS 0x300
undobuf	DS 0x1000	       ; undo buf

	ORG 0x6161

	JP INTUPT
stHere	JP START

INTUPT	PUSH AF,BC,DE,HL
	EXA
	EXX
	PUSH AF,BC,DE,HL,IX,IY

muzflag	SCF
	CALL NC,p1.play

	POP IY,IX,HL,DE,BC,AF
	EXA
	EXX
	POP HL,DE,BC,AF
	EI
	RET

; on/off muzic playing
MUZ_ON	LD A,#A7
	LD (muzflag),A
	RET
MUZ_OFF	LD A,#37
	LD (muzflag),A
	JP p1.mute

; start point
START	DI
	LD HL,#6000
	LD DE,#6001
	LD BC,#100
	LD A,H
	LD I,A
	INC A
	LD (HL),A
	LDIR
	IM 2
	CALL MUZ_OFF
	EI

	LD HL,COMPLET	; init levels state
	LD B,10
sta_A	LD (HL),6
	INC HL
	DJNZ sta_A
	LD B,20
sta_B	LD (HL),2
	INC HL
	DJNZ sta_B
	CALL MAKECOD

sta_REP	CALL CASHARR

	CALL MUZ_OFF
	ld C,1
	CALL INIT
	CALL MUZ_ON
	EI

	XOR A
	OUT (254),A
	LD HL,MainScr
	CALL OSCR_HL
	CALL BALLROW
	LD HL,#4828
	CALL outcode

	CALL SET_A_0
	CALL INITARR
sta_C
;	LD A,#BF
;	IN A,(254)
;	RRA
;	RET NC
	CALL TESTARR
	JR NC,sta_C

	LD A,C
	LD (chc_KY+1),A

	LD DE,(ARROWX)
	LD HL,MFldTab
sta_D	LD A,(HL)
	CP #FF
	JR Z,sta_C
	LD A,E
	SUB (HL)
	INC HL
	CP (HL)
	INC HL
	exa
	LD A,D
	SUB (HL)
	INC HL
	CP (HL)
	INC HL
	LD C,(HL)
	INC HL
	LD B,(HL)
	INC HL
	JR NC,sta_D
	exa
	JR NC,sta_D
	PUSH BC
	RET

MFldTab	DW #A030,#3008,GO_LEV
	DW #8040,#1048,CHA_COD
	DW #28C8,#1048,TRY_COD
	DB #FF

TRY_COD
	LD HL,#4E58
	LD C,5
	CALL PUSHBUT
	CALL NOFIRE
	LD HL,#4838
	LD C,5
	CALL POP_BUT
	CALL FROMCOD
	JR C,tcod_N
	CALL BALLROW
	CALL NOMOVE
	JP sta_C
tcod_N	LD A,2
	OUT (254),A
	LD B,20
	CALL B_HALT
	XOR A
	OUT (254),A
	CALL NOMOVE
	JP sta_C

	RET

CHA_COD	RRA
	RRA
	RRA
	RRA
	AND 7
	LD E,A
	LD D,0
chc_KY	LD C,0
	LD HL,GAMCODE
	ADD HL,DE
	BIT 6,C
	JR NZ,cod_DN
	LD A,(HL)
	CP #50
	JP Z,sta_C
	INC (HL)
	JR cod_AL
cod_DN	LD A,(HL)
	CP #41
	JP Z,sta_C
	DEC (HL)
cod_AL	CALL CASHARR
	LD HL,#4828
	CALL outcode
	CALL NOFIRE
	CALL INITARR
	JP sta_C

GO_LEV	RRA		; get level num
	RRA
	RRA
	RRA
	AND 15
	LD C,A
	exa
	RRA
	RRA
	RRA
	RRA
	AND 3
	ADD A,A
	LD B,A
	ADD A,A
	ADD A,A
	ADD A,B
	ADD A,C
	LD C,A
	LD B,0
	LD HL,COMPLET
	ADD HL,BC
	LD A,(HL)
	CP 2
	JP Z,sta_C
	LD HL,ButPAdr
	ADD HL,BC
	ADD HL,BC
	ADD HL,BC
	ADD HL,BC
	LD A,C
	INC A
	PUSH AF
	PUSH HL
	LD A,(HL)
	INC HL
	LD H,(HL)
	LD L,A
	LD C,2
	CALL PUSHBUT
	CALL NOFIRE
	POP HL
	INC HL
	INC HL
	LD A,(HL)
	INC HL
	LD H,(HL)
	LD L,A
	LD C,2
	CALL POP_BUT
	POP AF
	CALL LEVEL
	JP C,glev_N
	CALL DEL_FLD
	LD A,(Lev_Num)
	LD C,A
	LD B,0
	LD HL,COMPLET-1
	ADD HL,BC
	LD (HL),4
	LD HL,COMPLET
	LD C,"A"
	CALL IF_OPEN
	LD HL,COMPLET+10
	LD C,"B"
	CALL IF_OPEN
	LD HL,COMPLET+20
	LD C,"C"
	CALL IF_OPEN
	CALL MAKECOD
	CALL CASHARR
	CALL OUTCODE
	CALL INITARR
	CALL MUZ_OFF
	LD C,2
	CALL INIT
	CALL MUZ_ON
	EI
	CALL NOMOVE
saboz	CALL TESTARR
	JR NC,saboz
	CALL NOFIRE

MoreWin	AND A
	JR C,glev_N
	LD HL,COMPLET
	LD B,30
mwin_1	LD A,(HL)
	CP 4
	JR NZ,glev_N
	INC HL
	DJNZ mwin_1

	CALL MUZ_OFF
	LD C,3
	CALL INIT
	CALL MUZ_ON
	EI

	CALL CASHARR
	LD HL,Win_scr
	CALL OSCR_HL

	CALL NOKEY
	CALL WAITKEY
	CALL NOKEY

	LD A,#37
	LD (MoreWin),A

	CALL INITARR
	CALL NOMOVE
glev_N
	JP sta_REP

ButPAdr
	GETROW #4026,#4646
	GETROW #4066,#4686
	GETROW #40A6,#46C6

NOKEY	XOR A
	IN A,(254)
	CPL
	AND 31
	JR NZ,NOKEY
	RET

WAITKEY	XOR A
	IN A,(254)
	CPL
	AND 31
	JR Z,WAITKEY
	RET

IF_OPEN	LD B,10
ifop_1	LD A,(HL)
	CP 4
	RET NZ
	INC HL
	DJNZ ifop_1
	LD B,10
ifop_2	LD A,(HL)
	CP 2
	JR NZ,ifop_3
	LD (HL),6
ifop_3	INC HL
	DJNZ ifop_2
	LD A,C
	LD (GAMCODE),A
	RET

BALLROW	LD HL,COMPLET
	LD DE,#5826
	LD B,3
bsz_2	PUSH HL
	CALL ROW_10
	LD A,E
	ADD A,12
	LD E,A
	ADC A,D
	SUB E
	LD D,A
	POP HL
	CALL ROW_10
	LD A,E
	ADD A,12
	LD E,A
	ADC A,D
	SUB E
	LD D,A
	DJNZ bsz_2
	RET

ROW_10	LD C,10
bsz_3	LD A,(HL)
	LD (DE),A
	INC E
	LD (DE),A
	INC E
	INC HL
	DEC C
	JR NZ,bsz_3
	RET

DEL_FLD	LD B,20
	CALL B_HALT
	CALL CASHARR
	CALL OUT_SCR
	CALL SET_A_0
	CALL INITARR
	JP NOFIRE

MAKECOD	LD A,(GAMCODE)
	DEC A
	AND 15
	LD B,A
	LD A,(GAMCODE)
	LD HL,COMPLET
	CP "D"
	JR Z,mcod_1
	LD HL,COMPLET+10
	CP "A"
	JR Z,mcod_1
	LD HL,COMPLET+20
mcod_1	LD DE,GAMCODE+1
	LD A,5
mcod_2	exa
	LD C,#04
	LD A,(HL)
	CP 6
	RL C
	CALL SCF_RND
	RL C
	INC HL
	LD A,(HL)
	CP 6
	RL C
	CALL SCF_RND
	RL C
	INC HL
	LD A,C
	INC A
	LD (DE),A
	DEC A
	AND #0F
	ADD A,B
	LD B,A
	INC DE
	exa
	DEC A
	JR NZ,mcod_2
	LD A,B
	AND 15
	OR #40
	INC A
	LD (DE),A
	INC DE
	LD A,B
	RRA
	RRA
	RRA
	RRA
	AND 15
	OR #40
	INC A
	LD (DE),A
	RET

SCF_RND	PUSH HL
rnda	LD HL,0
	INC L
	LD (rnda+1),HL
	LD A,R
	XOR (HL)
	POP HL
	RRA
	RET

OUTCODE	LD HL,#4806
outcode	LD DE,GAMCODE
	LD B,8
ocod_1	PUSH BC
	PUSH DE
	PUSH HL
	LD A,(DE)
	DEC A
	AND 15
	LD HL,Symbolz
	LD DE,36
	CALL ADDING
	POP DE
	PUSH DE
	LD B,2
	CALL ofld_IN
	POP HL
	POP DE
	POP BC
	INC L
	INC L
	INC DE
	DJNZ ocod_1
	RET

FROMCOD	CALL TEST_CP
	RET C
	LD HL,COMPLET
	LD A,(GAMCODE)
	CP "D"
	JR Z,fcod_0
	CP "A"
	JR Z,fcod_1
	CP "B"
	JR Z,fcod_2
	LD B,30
fulc_1	LD (HL),4
	INC HL
	DJNZ fulc_1
	RET
fcod_2	LD B,20
	JR fcod_12
fcod_1	LD B,10
fcod_12	LD (HL),4
	INC HL
	DJNZ fcod_12
fcod_0	LD DE,GAMCODE+1
	LD B,5
fcod_A	LD A,(DE)
	DEC A
	AND #08
	LD (HL),4
	JR NZ,fcod_B
	LD (HL),6
fcod_B	INC HL
	LD A,(DE)
	DEC A
	AND #02
	LD (HL),4
	JR NZ,fcod_C
	LD (HL),6
fcod_C	INC HL
	INC DE
	DJNZ fcod_A
	LD B,20
fcod_Z	LD (HL),2
	INC HL
	DJNZ fcod_Z
	AND A
	RET

TEST_CP	LD HL,GAMCODE
	LD A,(HL)
	CP "D"
	JR Z,tcp_1
	CP "A"
	JR Z,tcp_1
	CP "B"
	JR Z,tcp_1
	CP "C"
	SCF
	RET NZ
tcp_1	INC HL
	DEC A
	AND 15
	LD C,A
	LD B,5
tcp_2	LD A,(HL)
	DEC A
	AND 15
	ADD A,C
	LD C,A
	LD A,(HL)
	DEC A
	AND #F0
	CP #40
	SCF
	RET NZ
	INC HL
	DJNZ tcp_2
	LD A,C
	AND 15
	OR #40
	INC A
	CP (HL)
	SCF
	RET NZ
	INC HL
	LD A,C
	RRA
	RRA
	RRA
	RRA
	AND 15
	OR #40
	INC A
	CP (HL)
	RET Z
	SCF
	RET

GAMCODE	DB "D.....--"
COMPLET	DS 30	       ; levels state
	DS 30,1	       ; 2-closed, 6-not completed, 4-completed

; izwrat muzic init
; in FUCKt, there is only 1 track, we just change start and loop position
INIT	push bc
	ld hl,muzic
	call p1.muzInit
	pop bc
	ld b,0
	ld hl,muzic
	add hl,bc
	add hl,bc
	ld b,h
	ld c,l
	ld hl,(p1.crpsptr)	; current pos
	ld a,(bc)
	ld e,a
	ld d,0
	ex de,hl
	add hl,de
	ld (p1.crpsptr),hl
	ex de,hl
	inc bc
	ld a,(bc)		; loop pos
	ld e,a
	add hl,de
	ld (p1.lposptr),hl
	ret


	
Symbolz	INCBIN "symbolz.bin"	; code symbols
MainScr	INCBIN "main_scr.pak"
Win_scr	INCBIN "winner.pak"

	INCLUDE	"paradox.asm"
LEVELS	INCLUDE	"parLevels.asm"

	INCLUDE	"pt3xplayer.asm",13
muzic	INCBIN "ingame15.pt3"

	display "code\t0x6161,",$-#6161,": ",$, " (",InHand - $, " free)"

	SAVESNA "pdx.sna",stHere